100 OPEN#0,con_: WINDOW#0,800,600,0,0 :INK#0,0:PAPER#0,7:CLS#0
110 OPEN#1,con_: WINDOW#1,800,600,0,0 :INK#1,0:PAPER#1,7:CLS#1
120 OPEN#2,con_: WINDOW#2,800,600,0,0 :INK#2,0:PAPER#2,7:CLS#2
130 OUTLN
140 AT#2,1,2:PRINT#2,'Convert Foxpro DBF files to DBAS files'
150 AT#2,2,2: INPUT#2,'Press Enter key to continue',ab$
160 REMark prepare arrays to extract data from DBF file
170 DIM ID_dbf_file$(1),DATE_update$(4),TOT_rec$(4),POS_1field$(2),LEN_dbf$(2),RES_1$(20),REC_detail$(32)
180 WHEN ERRor
190 erreur=ERNUM
200 IF erreur :REPORT_ERROR ERNUM,,,2 :PRINT ERNUM,ERLIN:PAUSE:QUIT
210 END WHEN
220 OPEN_DBF_FILE
230 OPEN_DBAS_FILE
240 WHEN ERRor
250 IF ERNUM:CLOSE#3:REPORT_ERROR ERNUM,,,2:PRINT ERNUM,ERLIN:PAUSE:QUIT:END IF
260 END WHEN
270 NAME_THE_FIELDS
280 REMark prepare array for field names and structure for DBAS
290 DIM nvv%(noMemo-1,1),newfield$(noMemo-1,11)
300 y=0
310 FOR x=0 TO numb_of_fields-2
320  IF  '-' INSTR name_of_field$(x+1)=0
330   REMark '-' ->picture and memo fields
340   nvv%(y,0)=veld%(x+1,0):nvv%(y,1)=veld%(x+1,1)
350   newfield$(y)=name_of_field$(x+1)
360   y=y+1
370  END IF
380 END FOR x
390 CREATE_O #5;dbas_file$\nvv%
400 FOR x=0 TO noMemo-1:STNAME#5,x+1,newfield$(x):END FOR x
410 SAVE_NAMES #5
420 CREATE_DBAS_FILE
430 CLOSE_DATA#5
440 :
450 DEFine PROCedure OPEN_DBF_FILE
460 REPeat loop
470 foxprofile$=FILE_SELECT$(' Which DBF file? ',,,'dbf',25+800,,,2,2)
480 IF  '.dbf' INSTR foxprofile$ OR '_dbf' INSTR foxprofile$
490  EXIT loop
500  ELSE
510  AT#2, 4,2:PRINT#2, 'Extension should be .DBF! Press ENTER key to quit':INPUT#2,ab$ :
520  STOP
530 END IF
540 END REPeat
550 WHEN ERRor
560 IF ERNUM:CLOSE#3:REPORT_ERROR ERNUM,,,2:PRINT ERNUM,ERLIN:PAUSE:QUIT:END IF
570 END WHEN
580 IF FOP_IN(#3,foxprofile$)=0
590 ELSE
600  AT#2, 4,2:PRINT#2, "Can't open "&foxprofile$&" Press ENTER key to quit":INPUT#2,ab$ :STOP:
610 END IF
620 AT#2,4,2:PRINT#2,'Looking for details':
630 BGET#3, ID_dbf_file$(1 TO 1)
640 BGET#3, DATE_update$(1 TO 3)
650 BGET#3, TOT_rec$(1 TO 4)
660 BGET#3, POS_1field$(1 TO 2)
670 BGET#3, LEN_dbf$(1 TO 2)
680 BGET#3, RES_1$(1 TO 20)
690 IF  ID_dbf_file$(1 TO 1) INSTR CHR$(3)&CHR$(131)&CHR$(139)&CHR$(245)=0
700  CLOSE_AND_QUIT 'not a valid DBF file'
710 END IF
720  lr4=CODE(TOT_rec$(4 TO 4)):lr3= CODE(TOT_rec$(3 TO 3)):
730  lr2= CODE(TOT_rec$(2 TO 2)):lr1= CODE(TOT_rec$(1 TO 1))
740  lr4$=HEX$(lr4,8):lr3$=HEX$(lr3,8):lr2$=HEX$(lr2,8):lr1$=HEX$(lr1,8)
750  number_of_rec=HEX(lr4$&lr3$&lr2$&lr1$)
760  IF  numb_of_rec>32767:CLOSE_AND_QUIT 'Too many records for DBAS':END IF
770  lfich1=CODE(LEN_dbf$(2)):lfich2=CODE(LEN_dbf$(1))
780  lfich1$=HEX$(lfich1,8):lfich2$=HEX$(lfich2,8):lfich=HEX(lfich1$&lfich2$)
790  IF  lfich>32767:CLOSE_AND_QUIT 'Record too long for DBAS':END IF
800  lf=0:long=0:numb_of_fields=1
810  REPeat loop
820  IF EOF(#3):EXIT loop:END IF
830   BGET#3,REC_detail$(1 TO 32)
840   IF CHR$(13) INSTR REC_detail$(1 TO 1):lf=lf+1:END IF
850   sous=CODE(REC_detail$(17 TO 17)):long=long+sous
860   numb_of_fields=numb_of_fields+1
870   IF lf=1
880    ba$=INKEY$(#3):PTR_file=FPOS(#3)-32
890    long=long-sous:numb_of_fields=numb_of_fields-1
900    EXIT loop
910   END IF
920  END REPeat loop
930 END DEFine OPEN_DBF_FILE
940 :
950 DEFine PROCedure NAME_THE_FIELDS
960 DIM veld%(numb_of_fields,1),len_of_field%(numb_of_fields)
970 DIM name_of_field$(numb_of_fields,11),type_of_field$(numb_of_fields,1),len_field$(numb_of_fields,2)
980 BGET#3\32
990 noMemo=0:REMark counter for unwanted field types (picture,memo)
1000 lf=0:rec_len=0: :code_field_type=0
1010 REMark lf LineFeed= next record
1020 FOR boucle=1 TO numb_of_fields-1
1030  BGET#3,REC_detail$(1 TO 32)
1040  IF CHR$(13) INSTR REC_detail$(1 TO 1):lf=lf+1:END IF
1050   name_of_field$(boucle)= REC_detail$(1 TO 11)
1060   type_of_field$(boucle)= REC_detail$(12 TO 12)
1070   len_of_field%(boucle)= CODE(REC_detail$(17 TO 17))
1080  code_field_type= CODE(type_of_field$(boucle))
1090  SELect ON code_field_type
1100  =67 :REMark string field
1110   noMemo=noMemo+1
1120   name_of_field$(boucle)=name_of_field$(boucle)
1130   :veld%(boucle,0)= 0:veld%(boucle,1)=len_of_field%(boucle)
1140  =68 :REMark date field
1150   noMemo=noMemo+1
1160   name_of_field$(boucle)=name_of_field$(boucle) :
1170   veld%(boucle,0)= 2: veld%(boucle,1)=len_of_field%(boucle)
1180  =77 :REMark memo field
1190   veld%(boucle,0)= -1: veld%(boucle,1)=len_of_field%(boucle)
1200   name_of_field$(boucle)=name_of_field$(boucle)&"-" :
1210  =80 :REMark picture field
1220   veld%(boucle,0)= -1: veld%(boucle,1)= len_of_field%(boucle)
1230   name_of_field$(boucle)=name_of_field$(boucle)&"-"
1240  =78,70 :REMark  numeric field
1250   noMemo=noMemo+1
1260   name_of_field$(boucle)=name_of_field$(boucle) :
1270   veld%(boucle,0)= 3: veld%(boucle,1)= len_of_field%(boucle)
1280  =76 :REMark  logical field
1290   noMemo=noMemo+1
1300   name_of_field$(boucle)=name_of_field$(boucle)&"$"
1310   veld%(boucle,0)= 0:veld%(boucle,1)=len_of_field%(boucle)
1320  =REMAINDER
1330   REMark should never get here
1340  END SELect
1350   REMark get rid of unwanted char in field name
1360   intnom$=name_of_field$(boucle):name_of_field$(boucle)=ALPHANUMONLY(intnom$)
1370   len_field$(boucle)= CODE(REC_detail$(17 TO 17))
1380   sous=CODE(REC_detail$(17 TO 17)):rec_len=rec_len+sous
1390   IF lf=1
1400    ba$=INKEY$(#3):PTR_file=FPOS(#3)-32
1410    rec_len=rec_len-sous+1
1420    EXIT boucle
1430   END IF
1440 END FOR boucle
1450 END DEFine NAME_THE_FIELDS
1460 :
1470 DEFine FuNction ALPHANUMONLY(a_n_str$)
1480 LOCal x,a$
1490 REMark get rid of unwanted char in field names (eg. trailing chr$(0))
1500 a$=""
1510 IF LEN(a_n_str$)=0:RETurn a_n_str$:END IF
1520 FOR x=1 TO LEN(a_n_str$)
1530  IF a_n_str$(x TO x) INSTR "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789$@-"
1540   a$=a$&a_n_str$(x TO x)
1550  END IF
1560 END FOR x
1570 RETurn a$
1580 END DEFine ALPHANUMONLY
1590 :
1600 DEFine PROCedure CREATE_DBAS_FILE
1610 LOCal x,bblock,field_type,Field_len
1620 Str_ptr=1:x=1:dbs_fldn=1 :bblock=0
1630 DIM record$(rec_len),rec_st$(1):fld_cont$=''
1640 BGET#3\PTR_file
1650 WHEN ERRor
1660 erreur=ERNUM:BEEP 1000,30,30:AT#2,4,0: CLS#2,3:AT#2,24,2:PRINT#2, ERLIN,' File probably corrupted  Press a key to quit'
1670 INPUT#2,ab$:REPORT_ERROR erreur,,,2:AT 25,0:PRINT ERLIN,ERNUM:PAUSE:CLOSE#1,#2,#3,#5:STOP
1680 END WHEN
1690  BLOCK#2, 106,14,98,98,2:INK#2,2:AT#2, 10,18:PRINT#2,'Please wait'
1700  REPeat loop
1710  IF EOF(#3):BEEP 100,100:EXIT loop :END IF
1720    BGET#3,rec_st$(1 TO 1)
1730  IF EOF(#3):BEEP 100,100:EXIT loop :END IF
1740  BGET#3,record$(1 TO rec_len)
1750   APPEND#5
1760  REPeat loopin
1770  IF Str_ptr>=rec_len:EXIT loopin:END IF
1780   field_type=veld%(x,0):Field_len= veld%(x,1)
1790   fld_cont$=record$(Str_ptr TO Str_ptr+Field_len-1)
1800   SELect ON field_type
1810   =-1:REMark  to get rid of memo and picture fields
1820   =0 :REMark string field
1830    SET#5,dbs_fldn,fld_cont$:UPDATE#5:dbs_fldn=dbs_fldn+1
1840   =1 :REMark integer
1850    IF alltrim(fld_cont$)='':fld_cont$='0':END IF
1860    SET#5,dbs_fldn,fld_cont$ :UPDATE#5:dbs_fldn=dbs_fldn+1:
1870   =2 :REMark  date field/long integer
1880    REMark if date field empty
1890    IF alltrim(fld_cont$)=""
1900     fld_cont$='19610101'
1910    END IF
1920    yr=fld_cont$(1 TO 4):mt=fld_cont$(5 TO 6):dy=fld_cont$(7 TO 8)
1930    SET#5,dbs_fldn,DATE(yr,mt,dy,0,0,0) :UPDATE#5:dbs_fldn=dbs_fldn+1:
1940   =3 :REMark numeric
1950    IF alltrim(fld_cont$)='':fld_cont$='0':END IF
1960    SET#5,dbs_fldn,fld_cont$:UPDATE#5:dbs_fldn=dbs_fldn+1:
1970   =REMAINDER
1980    REMark should never get here
1990   END SELect
2000  Str_ptr=Str_ptr+Field_len:x=x+1
2010  END REPeat loopin
2020   bblock=bblock+1: BLOCK  bblock,10,100,100,2
2030   IF bblock>100:BLOCK bblock,10,100,100,0:bblock=1::AT#2, 10,18:PRINT#2,'Please wait':END IF
2040  Str_ptr=1:x=1 :dbs_fldn=1
2050 END REPeat loop
2060 BLOCK#2, 100,10,100,100,7:INK#2,2:AT#2,10,18:PRINT#2,'Press a key':PAUSE
2070 END DEFine CREATE_DBAS_FILE
2080 :
2090 DEFine FuNction alltrim(xxx$)
2100 LOCal a$,b$,l,x
2110 REMark get rid of chr$(32)
2120 a$=" ":b$="":l=LEN(xxx$)
2130 IF xxx$="":RETurn "":END IF
2140 FOR x =1 TO l
2150  IF xxx$(x)==a$
2160  ELSE
2170   b$=b$&xxx$(x)
2180  END IF
2190 END FOR x
2200 RETurn b$
2210 END DEFine alltrim
2220 :
2230 DEFine PROCedure CLOSE_AND_QUIT (mesg$)
2240 LOCal ok$,x
2250 ok$=ITEM_SELECT('Message Box',mesg$,'Press a key',,,,,2)
2260 FOR x=5 TO 1 STEP -1:CLOSE#x:END FOR x
2270 STOP
2280 END DEFine CLOSE_AND_QUIT
2290 :
2300 DEFine PROCedure OPEN_DBAS_FILE
2310 REPeat loop
2320 dbas_file$=FILE_SELECT$(' To which DBAS file? ','test2','ram2_','_dbs',25+800,,,2,2)
2330 IF  '_dbs' INSTR dbas_file$  OR '.dbs' INSTR dbas_file$
2340  EXIT loop
2350  ELSE
2360  AT#2, 4,2:PRINT#2, 'Extension should be _dbs or .dbs! Press ENTER key to quit':INPUT#2,ab$ :
2370  CLOSE#3 :REMark close opened dbf file
2380  STOP
2390 END IF
2400 END REPeat loop
2410 END DEFine OPEN_DBAS_FILE
